part of 'generated.dart';

class ListRecentPaymentsByStatusVariablesBuilder {
  RecentPaymentStatus status;
  Optional<int> _offset = Optional.optional(nativeFromJson, nativeToJson);
  Optional<int> _limit = Optional.optional(nativeFromJson, nativeToJson);

  final FirebaseDataConnect _dataConnect;  ListRecentPaymentsByStatusVariablesBuilder offset(int? t) {
   _offset.value = t;
   return this;
  }
  ListRecentPaymentsByStatusVariablesBuilder limit(int? t) {
   _limit.value = t;
   return this;
  }

  ListRecentPaymentsByStatusVariablesBuilder(this._dataConnect, {required  this.status,});
  Deserializer<ListRecentPaymentsByStatusData> dataDeserializer = (dynamic json)  => ListRecentPaymentsByStatusData.fromJson(jsonDecode(json));
  Serializer<ListRecentPaymentsByStatusVariables> varsSerializer = (ListRecentPaymentsByStatusVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<ListRecentPaymentsByStatusData, ListRecentPaymentsByStatusVariables>> execute() {
    return ref().execute();
  }

  QueryRef<ListRecentPaymentsByStatusData, ListRecentPaymentsByStatusVariables> ref() {
    ListRecentPaymentsByStatusVariables vars= ListRecentPaymentsByStatusVariables(status: status,offset: _offset,limit: _limit,);
    return _dataConnect.query("listRecentPaymentsByStatus", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class ListRecentPaymentsByStatusRecentPayments {
  final String id;
  final String? workedTime;
  final EnumValue<RecentPaymentStatus>? status;
  final String staffId;
  final String applicationId;
  final String invoiceId;
  final Timestamp? createdAt;
  final Timestamp? updatedAt;
  final String? createdBy;
  final ListRecentPaymentsByStatusRecentPaymentsApplication application;
  final ListRecentPaymentsByStatusRecentPaymentsInvoice invoice;
  ListRecentPaymentsByStatusRecentPayments.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  workedTime = json['workedTime'] == null ? null : nativeFromJson<String>(json['workedTime']),
  status = json['status'] == null ? null : recentPaymentStatusDeserializer(json['status']),
  staffId = nativeFromJson<String>(json['staffId']),
  applicationId = nativeFromJson<String>(json['applicationId']),
  invoiceId = nativeFromJson<String>(json['invoiceId']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  updatedAt = json['updatedAt'] == null ? null : Timestamp.fromJson(json['updatedAt']),
  createdBy = json['createdBy'] == null ? null : nativeFromJson<String>(json['createdBy']),
  application = ListRecentPaymentsByStatusRecentPaymentsApplication.fromJson(json['application']),
  invoice = ListRecentPaymentsByStatusRecentPaymentsInvoice.fromJson(json['invoice']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPayments otherTyped = other as ListRecentPaymentsByStatusRecentPayments;
    return id == otherTyped.id && 
    workedTime == otherTyped.workedTime && 
    status == otherTyped.status && 
    staffId == otherTyped.staffId && 
    applicationId == otherTyped.applicationId && 
    invoiceId == otherTyped.invoiceId && 
    createdAt == otherTyped.createdAt && 
    updatedAt == otherTyped.updatedAt && 
    createdBy == otherTyped.createdBy && 
    application == otherTyped.application && 
    invoice == otherTyped.invoice;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, workedTime.hashCode, status.hashCode, staffId.hashCode, applicationId.hashCode, invoiceId.hashCode, createdAt.hashCode, updatedAt.hashCode, createdBy.hashCode, application.hashCode, invoice.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (workedTime != null) {
      json['workedTime'] = nativeToJson<String?>(workedTime);
    }
    if (status != null) {
      json['status'] = 
    recentPaymentStatusSerializer(status!)
    ;
    }
    json['staffId'] = nativeToJson<String>(staffId);
    json['applicationId'] = nativeToJson<String>(applicationId);
    json['invoiceId'] = nativeToJson<String>(invoiceId);
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    if (updatedAt != null) {
      json['updatedAt'] = updatedAt!.toJson();
    }
    if (createdBy != null) {
      json['createdBy'] = nativeToJson<String?>(createdBy);
    }
    json['application'] = application.toJson();
    json['invoice'] = invoice.toJson();
    return json;
  }

  ListRecentPaymentsByStatusRecentPayments({
    required this.id,
    this.workedTime,
    this.status,
    required this.staffId,
    required this.applicationId,
    required this.invoiceId,
    this.createdAt,
    this.updatedAt,
    this.createdBy,
    required this.application,
    required this.invoice,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsApplication {
  final String id;
  final ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRole shiftRole;
  ListRecentPaymentsByStatusRecentPaymentsApplication.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  shiftRole = ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsApplication otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsApplication;
    return id == otherTyped.id && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsApplication({
    required this.id,
    required this.shiftRole,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRole {
  final double? hours;
  final double? totalValue;
  final ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleRole role;
  final ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleShift shift;
  ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRole.fromJson(dynamic json):
  
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleRole.fromJson(json['role']),
  shift = ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleShift.fromJson(json['shift']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRole otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRole;
    return hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role && 
    shift == otherTyped.shift;
    
  }
  @override
  int get hashCode => Object.hashAll([hours.hashCode, totalValue.hashCode, role.hashCode, shift.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    json['shift'] = shift.toJson();
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRole({
    this.hours,
    this.totalValue,
    required this.role,
    required this.shift,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleRole otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleShift {
  final String id;
  final String title;
  final Timestamp? date;
  final String? locationAddress;
  ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  locationAddress = json['locationAddress'] == null ? null : nativeFromJson<String>(json['locationAddress']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleShift otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    locationAddress == otherTyped.locationAddress;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, locationAddress.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (locationAddress != null) {
      json['locationAddress'] = nativeToJson<String?>(locationAddress);
    }
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsApplicationShiftRoleShift({
    required this.id,
    required this.title,
    this.date,
    this.locationAddress,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsInvoice {
  final String id;
  final String invoiceNumber;
  final EnumValue<InvoiceStatus> status;
  final double amount;
  final ListRecentPaymentsByStatusRecentPaymentsInvoiceBusiness business;
  final ListRecentPaymentsByStatusRecentPaymentsInvoiceVendor vendor;
  final ListRecentPaymentsByStatusRecentPaymentsInvoiceOrder order;
  ListRecentPaymentsByStatusRecentPaymentsInvoice.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  invoiceNumber = nativeFromJson<String>(json['invoiceNumber']),
  status = invoiceStatusDeserializer(json['status']),
  amount = nativeFromJson<double>(json['amount']),
  business = ListRecentPaymentsByStatusRecentPaymentsInvoiceBusiness.fromJson(json['business']),
  vendor = ListRecentPaymentsByStatusRecentPaymentsInvoiceVendor.fromJson(json['vendor']),
  order = ListRecentPaymentsByStatusRecentPaymentsInvoiceOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsInvoice otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsInvoice;
    return id == otherTyped.id && 
    invoiceNumber == otherTyped.invoiceNumber && 
    status == otherTyped.status && 
    amount == otherTyped.amount && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, invoiceNumber.hashCode, status.hashCode, amount.hashCode, business.hashCode, vendor.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['invoiceNumber'] = nativeToJson<String>(invoiceNumber);
    json['status'] = 
    invoiceStatusSerializer(status)
    ;
    json['amount'] = nativeToJson<double>(amount);
    json['business'] = business.toJson();
    json['vendor'] = vendor.toJson();
    json['order'] = order.toJson();
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsInvoice({
    required this.id,
    required this.invoiceNumber,
    required this.status,
    required this.amount,
    required this.business,
    required this.vendor,
    required this.order,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsInvoiceBusiness {
  final String id;
  final String businessName;
  ListRecentPaymentsByStatusRecentPaymentsInvoiceBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsInvoiceBusiness otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsInvoiceBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsInvoiceBusiness({
    required this.id,
    required this.businessName,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsInvoiceVendor {
  final String id;
  final String companyName;
  ListRecentPaymentsByStatusRecentPaymentsInvoiceVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsInvoiceVendor otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsInvoiceVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsInvoiceVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class ListRecentPaymentsByStatusRecentPaymentsInvoiceOrder {
  final String id;
  final String? eventName;
  final String? location;
  ListRecentPaymentsByStatusRecentPaymentsInvoiceOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusRecentPaymentsInvoiceOrder otherTyped = other as ListRecentPaymentsByStatusRecentPaymentsInvoiceOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    location == otherTyped.location;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, location.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    return json;
  }

  ListRecentPaymentsByStatusRecentPaymentsInvoiceOrder({
    required this.id,
    this.eventName,
    this.location,
  });
}

@immutable
class ListRecentPaymentsByStatusData {
  final List<ListRecentPaymentsByStatusRecentPayments> recentPayments;
  ListRecentPaymentsByStatusData.fromJson(dynamic json):
  
  recentPayments = (json['recentPayments'] as List<dynamic>)
        .map((e) => ListRecentPaymentsByStatusRecentPayments.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusData otherTyped = other as ListRecentPaymentsByStatusData;
    return recentPayments == otherTyped.recentPayments;
    
  }
  @override
  int get hashCode => recentPayments.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['recentPayments'] = recentPayments.map((e) => e.toJson()).toList();
    return json;
  }

  ListRecentPaymentsByStatusData({
    required this.recentPayments,
  });
}

@immutable
class ListRecentPaymentsByStatusVariables {
  final RecentPaymentStatus status;
  late final Optional<int>offset;
  late final Optional<int>limit;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  ListRecentPaymentsByStatusVariables.fromJson(Map<String, dynamic> json):
  
  status = RecentPaymentStatus.values.byName(json['status']) {
  
  
  
    offset = Optional.optional(nativeFromJson, nativeToJson);
    offset.value = json['offset'] == null ? null : nativeFromJson<int>(json['offset']);
  
  
    limit = Optional.optional(nativeFromJson, nativeToJson);
    limit.value = json['limit'] == null ? null : nativeFromJson<int>(json['limit']);
  
  }
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStatusVariables otherTyped = other as ListRecentPaymentsByStatusVariables;
    return status == otherTyped.status && 
    offset == otherTyped.offset && 
    limit == otherTyped.limit;
    
  }
  @override
  int get hashCode => Object.hashAll([status.hashCode, offset.hashCode, limit.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['status'] = 
    status.name
    ;
    if(offset.state == OptionalState.set) {
      json['offset'] = offset.toJson();
    }
    if(limit.state == OptionalState.set) {
      json['limit'] = limit.toJson();
    }
    return json;
  }

  ListRecentPaymentsByStatusVariables({
    required this.status,
    required this.offset,
    required this.limit,
  });
}

